Перейти к содержанию
  • записей
    7
  • комментариев
    10
  • просмотра
    814

О блоге

мысли и возможно полезное

Записи в этом блоге

doctorraz

АвтоЗаполнялка


Автоматизация

По мотивам видео уважаемого  @MCAD

Спойлер

 

Собрал заполнялку форматок СПДС на основе таблиц...

Коротенько что умеет и зачем...

1. Заполняет реквизитную часть основных надписей

Спойлер

image.png.bb1eb081fccbcb24f20583517a64d91d.png

 

Но в связи с тем, что в таблицах бага (несколько (много ) отчетов начинают глючить, а мне надо много)

Эта таблица  заполняет данными другие таблицы..

Собирает данные с форматов в чертеже (мне надо для статистики по разделам, листов и приведение к А1)

UPD 19.05.2021  15:50 Заполняет данными  блок с атрибутами (иначе как мне взять полем в текст или мтекст??)  

И берет с этого блока поля  имени файла и путь файла ( заодно объехали еще одну багу с отцепляющимися полями в таблице при изменении в таблице количества строк и еще одну багу лишний пробел в начале строки)

из за баги в нано (атрибуты из блоков в тексты не держатся, слетают и глючит)

поэтому написал простенький VBA который значения именованных ячеек таблицы записывает в пользовательские свойства документа, а вот оттуда уже можно подтянуть полем в любой объект.

Бонусом при вставке текста с полем в любой документ, если у документа есть такие пользовательские свойства все подтянется автоматически.

Продолжение истории))/UPD

-------------------

Маленькие таблицы:

непосредственно заполняют основные надписи форматок

нумеруют форматки (слева направо снизу вверх, можно перенастроить)

В первом формате ставят количество форматов.

В маленьких таблицах нужно только  задать область в которой расположен раздел и имя раздела (то что в обозначении после точки... СО, КЖ, Д, Р)

Спойлер

image.png.7e4d14d7f36dfeff725a55aa331dba47.png

Кому интересно качайте шаблончик, включайте скрытые строки и разделы (их там есть), разбирайтесь как это работает и конечно адаптируйте под свои нужды (кто проектирует проект файл)

Связи можно посмотреть-проверить по SPREFSHOW

------------------------

Критика только приветствуется))

ЗЫ возможно чего вспомню еще допишу, но проще раз увидеть

------------

upd перезалил шаблон, чегойто два файла прицепилось)))

 

 

Автозаполнялка.dwg

doctorraz

На днях колеги подогнали файл со схемами предприятия

Спойлер

image.thumb.png.d5ca87365d58717b344e4251b916f75f.png

Ну а чо они так видят, им удобно и они в этом чертеже ориентируются вполне комфортно, в отличие от меня.

Вблизи схемы как схемы

Спойлер

image.png.f1892224685a73e1967b980200c68463.png

 

Спойлер

image.png.92c36affa2cf64d370d4eb951b4d61b4.png

Среди этой красоты мне нужно было найти определенную подстанцию ТП-8/7 и фидера откуда она питается

 

Спойлер

image.png.60d838cd59af854898e29137f709ce1c.png

Долог и неинформативен

Благо коллеги в кадах не сильно искушены и все надписи были сделаны просто текстом

И я подумал ведь есть служебная команда SPREFSHOW которая укажет мне путь)))

Добавил таблицу на чертеж

Добавил раздел  отчета

Спойлер

image.png.0b8c0959d042f105cb49a15c7628576c.png

если кому надо искать в мтекстах или других объектах, то добавляется по аналогии...

Для того что бы показывало объекты по SPREFSHOW, должно быть взято хотя бы одно свойство с объекта, ничего оригинальнее чем  взять =Object.Text я придумать не смог

Больше свойств брать не стоит, лишние связи будут мешать, загромождать... короче не надо

Ну и для перфекционизму объединил первый столбец и поставил на него счетчик

Спойлер

image.png.f91b5ca8fba591ca819a7c1c79375a4a.png

выходим из редактора таблиц

выделяем нашу табличку и в ком строке вводим вожделенное SPREFSHOW

Спойлер

image.thumb.png.04bd57f69fdaced8bc19609907725104.png

линии связей укажут искомое)))

---------------

ЗЫ мне реально лениво переключаться на инглиш раскладку, а потом еще и набирать такое длинное слово

можно добавить через НПИ в команды, менюшки и панельки..... но тогда нано,  все мои красиво расположенные  функциональные и не очень панельки смешает в кучу..

я работаю в основном из ком строки..

поэтому добавил в подгружаемый lisp команду

(defun C:спсс ();;Показать зависимости
	(command "SPREFSHOW" ) 
	(princ)
) 

благо что lisp команды можно добавлять, изменять не перезагружая нану (достаточно перезагрузить лисп))))..

в отличие от добавления команд через интуитивно понятный и чертовски удобный НПИ(((который после рестарта нано нарушит гармонию панелек настроенных мной, на строгий порядок определенный суровым разработчиком)))

doctorraz

Сделал автозаполнялку , по результатам боевых стрельб внезапно выяснилось, что нана не умеет работать с полями нативных объектов.

Зато умеет вставлять поля из свойств документа (хотя возможно в следующей версии пофиксят и все будет наоборот)))

Возник вопрос, как запихнуть данные в  свойства документа....

Руками прям не вдохновляет

Спойлер

image.png.d238428f6d075708067bb818e58b3ebf.png

Второй вопрос откуда эти данные брать, решился просто, коль у нас на чертеже есть таблица, (автозаполнялка)  в которую мы занесли все сведения...

отчего бы данные не подтянуть из нее.

Принцип в кратце:

  1. Хватаем конкретную таблицу на чертеже
  2. Пробегаем по значениям именованных ячеек
  3. Имя ячейки пишем как ключ в пользовательские свойства документа
  4. Значением-свойством ключа будет содержимое ячейки

------------------------

Некритичные проверки исключений я не делал, кому надо вполне может дописать, как надо

Если изменить "комментарии"  ячеек, то соответственно в свойства документа запишутся другие ключи

Все ключи пишутся в пользовательские свойства документа, но при желании можно писать и в 

Спойлер

image.png.d1d023e4dfff1ade16c008af0f79a073.png

 

Под спойлером код, старался комментировал))

 

Спойлер



Dim ThisDrawing As Object
Sub docProp() 'заполнялка полей документа из таблицы (именованных ячеек)
    'без проверки исключений, чисто для общего понятия как
    Set objApp = GetObject(, "nanoCAD.Application") 'цепляемся к нане, или AutoCAD
    Set SPDS = CreateObject("McCOM2.Server") 'Получаем COM-сервер СПДС
    Set ThisDrawing = objApp.ActiveDocument 'хватаем активный документ
    Set ff = ThisDrawing
    TabName = "Заполнялка Таблица в таблицы" 'эту таблицу будем искать на чертеже
    Set FindTable = SPDS.Query("McCom2.SymTable", "Name=""" & TabName & """") _
            'ищем таблицу, можно изменить на свое
       If FindTable.Count > 0 Then 'если хоть одна таблица с таким именем найдена
        Set PropTable = FindTable(1).Properties 'хватаем первую из коллекции с таким именем (предполагается, что она одна)))
Dim varr
'<тут готовим путь для записи в таблицу (мне так надо)
        If ThisDrawing.FullName Like "*\*" Then 'НАНОКОСТЫЛЬ если файл сохранялся
            FulPatch = ThisDrawing.FullName
'<тут получаем имя файла без расширения
            varr = Split(ThisDrawing.Name, ".")
ReDim Preserve varr(UBound(varr) - 1)
            Filename = Join(varr, "")
        Else
            FulPatch = "ФАЙЛ НЕ СОХРАНЯЛСЯ!!"
            Filename = ThisDrawing.Name
        End If
Dim PropKey As String 'ключ для записи в свойства документа (коментарий ячейки)
Dim PropVal As String 'свойство ключа)) (содержимое ячейки)
On Error Resume Next 'страховочка вдруг такой ячейки нет((
        PropTable("Путь к файлу") = FulPatch 'пишем в ячейку полный путь
        PropTable("Имя файла") = Filename 'пишем в ячейку имя файла
On Error GoTo 0
    'тут в цикле заполняем свойства документа из именованных ячеек
        For Each namProp In PropTable.Names 'перебираем имена свойств
            Set PropProp = PropTable(namProp) 'получаем свойство по имени
            PropCategory = PropProp.Category
            If PropCategory = "Именованные ячейки" Then 'из свойств нам нужны только именованные ячейки
                PropKey = namProp 'коментарий ячейки будет ключ
                PropVal = PropProp.Value 'значение ячейки
                SetOrAddKey PropKey, PropVal 'идем писать в свойства
            End If
        Next
        res = "Значения именованных ячеек из " & "<" & TabName & ">" & _
                " записаны в свойства документа"
        ThisDrawing.SendCommand "(alert """ & res & """)" & vbCrLf
        SPDS.Message (res)
    Else
        MsgBox "Таблица: """ & TabName & """" & vbCrLf & _
                "не найдена на чертеже!", vbInformation, "docProp"
    End If
End Sub
    
Function SetOrAddKey(Key1 As String, val As String)
On Error Resume Next
    ThisDrawing.SummaryInfo.SetCustomByKey Key1, val 'НАНОКОСЯК если ключа нет в каде будет исключение, но нана создаст ключ)))
    If Err.Number <> 0 Then
        ThisDrawing.SummaryInfo.AddCustomInfo Key1, val
        Err.Number = 0
    End If
On Error GoTo 0
End Function
Sub main()
    docProp
End Sub

 

 

Сразу скажу из скрипта VBS внутри наны этот код работать не будет, хотя конечно заманчиво... (значения ключей и свойства должны быть String и никак иначе, а в скриптах типы данных я не умею )

Поэтому этот код запускается из Excel большой красной кнопкой.

В принципе, как дальнейшее развитие, этот код можно причесать, откомпилировать и запускать, хоть из командной строки нано, из меню или кнопкой на панели.

В аттаче шаблон чертежа и большая красная кнопка.

PS кода без багов не бывает, поэтому по мере... буду улучшать

Автозаполнялка через поля документа V2.dwg docProp.xlsm

doctorraz

В рамках самообучения VB.NET решил портировать VBA из Автозаполнялка. Часть 2

Естественно, я сильно не заморачивался, просто добавил нужные функции для себя, ну и прикрутил интерфейс для других))

Для чего это нужно можете прочитать выше по ссылке...

Возможности утилиты:

  • Работает с нанокад и автокад+СПДС
  • Удаление всех пользовательских свойств документа DWG
  • Добавляет пользовательские свойства в активный документ из таблиц nanoCad (именованные ячейки)
    • прямым выбором таблиц на чертеже
    • сохраненное имя таблицы из настроек
  • режим ком строки (без интерфейса) ключи:
    • без ключа-поведение определяется настройкой утилиты, возможны опции:
      • Открыть настройки (интерфейс)
      • Записать в свойства документа данные из имени таблицы сохраненной в настройках
      • Выбрать таблицу для записи в свойства документа на чертеже
    • 1-Записать в свойства документа данные из имени таблицы сохраненной в настройках
    • 2-Выбрать таблицу для записи в свойства документа на чертеже
    • любой другой ключ-Интерфейс, откроется окно настроек
  • Обновление утилиты онлайн (в смысле при наличии интернета, сама проверит обновление и попросит обновиться)

=====================

В принципе функционал можно  наращивать до бесконечности (если кто-то проявит интерес)...собирал для себя, то что необходимо мне)))

upd Накрутил там еще шашечек))) по мелочи и продолжаю пилить

Спойлер

image.png.6ac2f36c414224b52b044508985377ba.png

Спойлер

image.png.85137f1639a2cbf8695776ce67157751.png

 

image.png.aece71222de3bef4337f5d0b958c92a5.png

 

 

 

Как всегда конструктивная и не очень критика, а также замечания и пожелания только приветствуются

DocProp.exe.zip Заполнялка Таблица в таблицы.dwg

doctorraz

Disclaimer сразу оговорюсь, способа узнать ID объекта в платформе пока не существует (по крайней мере мне неизвестно).
Хотя разработчики могли бы добавить такую возможность, например в утилиту конфигурации. 
 
Но подставить костылики можно.

Простой способ открыть в мастере объектов и посмотреть ID не рассматриваем (СПДС, Механик и прочие вертикалки работодатель не купил, а пробник выдохся))))

_________________________________________________________

 

Для чего нужен этот ID?

Для того, что бы иметь возможность в вставлять таблицы с кнопок, палитры инструментов или посредством lisp из командной строки. 

Вот такое выражение для кнопок, менюшек и инструментов:

^C^C_stdselected <ID>

 

для lisp (кстати лисп выражения прекрасно работают в менюшках и инструментах)

(defun C:ИмяКоманды ()
  (command "spStdSelected" "<ID>")
  (princ)
) 

Что такое этот ID?

Уникальный идентификатор объекта в базе данных (БД), именно по нему программа узнает какой объект вставить на чертеж.

Что мы знаем о таблицах и их ID?

У каждой таблицы в БД есть свой ID:

  1. Если перемещать таблицу внутри базы по "каталогам", ID не изменяется;
  2. Если переименовать таблицу , ID не изменяется;
  3. Если утилитой конфигурации экспортировать таблицу, у экспортированной ID будет такой же;
  4. Если импортировать таблицу в базу, у импортированной будет тот же ID, но
    если в базе таблица с таким ID уже есть она будет перезаписана импортируемой (независимо от имени);
  5. Если в в каталоге базы есть таблица с другим ID, но таким же именем, то при импорте таблица перезаписана не будет ( в этом каталоге будут две одноименные таблицы);
  6. После вставки на чертеж ID у таблицы на чертеже нет;
  7. Если после редактирования на чертеже сохранить в "каталог" базы одноименную таблицу,  ID таблицы которая была в базе не изменится.

Что дает нам это знание?

  1. Можно сделать экспорт из БД интересующих объектов и попросить имеющих СПДС импортировать их к себе, посмотреть ID,
    вариант рабочий, но далеко не каждый имеет БД для тестов и поэтому вряд ли будет импортировать себе неизвестно, что с риском перезаписать свои объекты;
  2. Можно модифицировать и перезаписать стандартные таблицы из БД (их ID можно посмотреть в инструментах)
    как по мне так себе идея  модифицировать стандартные объекты, при обновлении базы могут перезаписаться опять стандартными;
  3. Можно импортировать в свою БД таблицы с заранее известными ID и в дальнейшем работать с ними

Суть идеи...

  1. Загружаем в свою базу таблицы отсюда  
    в архиве *.mcd таблицы пустышки, имя таблицы, ее ID;
  2. Импортируем таблицы в свою БД в любое место;
  3. Запоминаем имена-ID таблиц либо сразу привязываем их на кнопки и в инструменты;
  4. В утилите конфигурации переименовываем таблицы, как требуется, там же в утилите можно переместить таблицы в нужные каталоги.
  5. Свои настроенные таблицы из БД вставляем на чертеж (либо настраиваем непосредственно на чертеже)
  6. Сохраняем таблицы с чертежа в БД 
    !!!Важно в тот же каталог и под тем же именем, где лежит таблица пустышка (с заранее известным ID)
    Настроенная таблица перезапишет ту, что в базе, но ID не измениться;
  7. Профит, пользуемся и :prey: разработчикам, что бы они добавили возможность посмотреть ID  в "голую" платформу

---------------

PS Если вдруг кто не в курсе

Спойлер

image.png.5210dcae15fde4d1c66586939616e71b.png

 

Спойлер

image.thumb.png.29242fbe4d57a5a3d35aa6df63d384fa.png

Спойлер

image.png.f228d66e60294bade5e679745996febd.png

Никак не связаны и не обязательно должны совпадать, 

doctorraz

В nano  20.х добавили функциональную панель "Инструменты" (в Autocad называлось палитра)

Сама по себе неплохая штука и порой весьма удобная.. 

Но местами весьма глючная, а глючная в плане того, что при вставке блоков путает порядок прорисовки и поднимает маскировку этих блоков на передний план.

Спойлер

image.png.7272304427ec9180111ece44bccd437b.png

В nano21 эту багу исправили.

В принципе казалось бы, в чем проблема..

открой блок на редактирование и утопи маскировку, ан нет, nana20 не умеет редактировать динамические блоки.

Да и статические после вставки нового блока с функциональной панели "Инструментов" каждый раз править, то еще удовольствие(((

Но решение достаточно простое

Спойлер

#if NC
using Teigha.DatabaseServices;
using Teigha.Runtime;
using HostMgd.ApplicationServices;
using HostMgd.EditorInput;

#else
using Autodesk.AutoCAD.ApplicationServices;
using Autodesk.AutoCAD.DatabaseServices;
using Autodesk.AutoCAD.EditorInput;
using Autodesk.AutoCAD.Runtime;
#endif
namespace drz
{
    public class Utils : IExtensionApplication

    {
        [CommandMethod("drz-WipBot", CommandFlags.Modal)]
        public void WipeoutToBotton()
        /*Топит маскировку внутри блоков
         */
        {
            Document doc = Application.DocumentManager.MdiActiveDocument;
            Database db = doc.Database;
            Editor ed = doc.Editor;
            int count = 0;
            //using (Transaction tr = db.TransactionManager.StartOpenCloseTransaction())//вот нельзя тут так делать, только для UpgradeOpen(), DowngradeOpen();
//иначе Автокад валится, нане пофих
            using (Transaction tr = db.TransactionManager.StartTransaction())  
            {
                BlockTable bt = (BlockTable)tr.GetObject(db.BlockTableId, OpenMode.ForRead);
                foreach (ObjectId btrId in bt)
                {
                    BlockTableRecord btr = (BlockTableRecord)tr.GetObject(btrId, OpenMode.ForRead);
                    if (!btr.IsFromExternalReference && !btr.IsDependent && !btr.IsLayout)// not xref and not xref|block and not Layout
                    {
                        foreach (ObjectId id in btr)
                        {
                            Entity ent = tr.GetObject(id, OpenMode.ForRead) as Entity;
                            if (ent != null)
                            {
                                Wipeout wpt = ent as Wipeout;
                                if (wpt != null)//если маскировка
                                {
                                    // получаем таблицу порядка отрисовки блока
                                    DrawOrderTable drawOrder =
                                                         tr.GetObject(btr.DrawOrderTableId,
                                                        OpenMode.ForWrite) as DrawOrderTable;
                                    ObjectIdCollection ids = new ObjectIdCollection();
                                    ids.Add(wpt.ObjectId);
                                    drawOrder.MoveToBottom(ids);//топим маскировку
                                    count++;
                                }
                            }
                        }
                    }
                }
                tr.Commit();
            }
            ed.Regen();
            ed.WriteMessage(
                "Move to bottom in blocks " + count + " wipeout"
                );
        }
        //-----------------------------
        public void Initialize()
        {
            Editor ed = Application.DocumentManager.MdiActiveDocument.Editor;
            ed.WriteMessage("\n\"drz\" загружен");
            ed.WriteMessage("\nВызов drz-WipBot");
        }
        public void Terminate()
        {
        }
    }
}

 

Проходит по всем описаниям блоков находит в них маскировки и топит их на дно.

вызов из командной строки drz-WipBot

Тестировался в nano20.1-21, Autocad2018-2021 (естественно в каждый CAD) надо загружать свою сборку (NETLOAD или APPLOAD)

Спойлер

image.png.7ac6ed6a44526d85dd51caf806d556f6.png

Форум не позволяет загружать dll и архивы, поэтому ссылка на сборку и там же пример блоков которые режут линию под собой

doctorraz

Attsync. Альтернатива


Автоматизация

  Ждать пока nanoDev выгребет все баги мне некогда, работать надо сейчас, поэтому...

Под свои потребности сделал сборочку, на основе кода Андрея Бушмана (с небольшими изменениями).

взять сборочку можно тут: https://disk.yandex.ru/d/87lVPPumz3FPzA

В архиве две сборки под Autocad 2018-2021 и nanoCad 21. Также в архиве простенький тестовый dwg пример.

Для вызова доступны две команды:

  1. от Андрея Бушмана drz-MySynch

что делает:

  • синхронизирует атрибуты блоков с их описанием, но при этом не смещает, не вращает атрибут в положение по умолчанию. т.е. после синхронизации все существующие в описании атрибуты по идее остаются на своих местах;
  • не изменяет состояние видимости вхождения блока;
  • удаленные в описании блока атрибуты из вхождения удаляются, добавленные в описание блока добавляются во вхождения (если есть значение по умолчанию, то с этими значениями)

   2. от Gilles Chanteau drz-MySynchHard

 что делает:

  • то что должен был делать Attsync в nanoCad 21, только по нормальному (без удаления значений атрибутов и видит атрибуты в измененных дин блоках)

!!!! Важно:

  •  drz-MySynch работает только в nanoCad  21, в nanoCad  20.х некоторые .NET методы не реализованы (либо я не разобрался, как((();
  • drz-MySynchHard в nanoCad  20 обрабатывает только статические блоки, в nanoCad  21 обрабатывает все;
  • Тестировалось на nanoCad х64 (теоретически должно и на х86 работать, если надо пересоберу без проблем);
  • На автокад не тестировалось, но по опыту предыдущих стрельб должно работать на АК2018-2021

Короче кому интересно скачивайте пробуйте.

×
×
  • Создать...